program ProjectAPIm;

type
  I64 = record Lo, Hi: Cardinal;
  end;

type
  PSHQueryRBInfo = ^TSHQueryRBInfo;
  TSHQueryRBInfo = packed record
    cbSize: Cardinal;
    i64Size: I64;
    i64NumItems: I64;
  end;

var
  fWnd, L1, L2: Cardinal;
  Wnd : packed record
    style         : Cardinal;
    lpfnWndProc   : Pointer;
    cbClsExtra    : Integer;
    cbWndExtra    : Integer;
    hInstance     : Cardinal;
    hIcon         : Cardinal;
    hCursor       : Cardinal;
    hbrBackground : Cardinal;
    lpszMenuName  : PAnsiChar;
    lpszClassName : PAnsiChar;
  end;

  msg : packed record
    hwnd    : Cardinal;
    message : Cardinal;
    wParam  : Integer;
    lParam  : Integer;
    time    : Cardinal;
    X, Y    : Integer;
  end;

function CreateWindowEx(dwExStyle: Cardinal; lpClassName: PChar; lpWindowName: PChar; dwStyle: Cardinal; X, Y, nWidth, nHeight: Integer; hWndParent, hMenu, hInstance: Cardinal; lpParam: Pointer): Cardinal; stdcall; external 'user32.dll' name 'CreateWindowExA';
function DefWindowProc(hWnd, Msg: Cardinal; wParam, lParam: Integer): Integer; stdcall; external 'user32.dll' name 'DefWindowProcA';
function DispatchMessage(lpMsg: Pointer): Integer; stdcall; external 'user32.dll' name 'DispatchMessageA'
function GetMessage(lpMsg: Pointer; hWnd, wMsgFilterMin, wMsgFilterMax: Cardinal): Boolean; stdcall; external 'user32.dll' name 'GetMessageA';
function GetSystemMetrics(nIndex: Integer): Integer; stdcall; external 'user32.dll' name 'GetSystemMetrics';
function KillTimer(hWnd: Integer; uIDEvent: Cardinal): Boolean; stdcall; external 'user32.dll' name 'KillTimer';
function LoadCursor(hInstance: Cardinal; lpCursorName: PChar): Cardinal; stdcall; external 'user32.dll' name 'LoadCursorA';
function LoadIcon(hInstance: Cardinal; lpIconName: PChar): Cardinal; stdcall; external 'user32.dll' name 'LoadIconA';
function RegisterClass(lpWndClass: Pointer): Cardinal; stdcall; external 'user32.dll' name 'RegisterClassA';
function SetTimer(hWnd: Integer; nIDEvent, uElapse: Cardinal; lpTimerFunc: Pointer): Cardinal; stdcall; external 'user32.dll' name 'SetTimer';
function SetWindowText(hWnd: Integer; lpString: PChar): Boolean; stdcall; external 'user32.dll' name 'SetWindowTextA';
function SHQueryRecycleBin(szRootPath: PChar; SHQueryRBInfo: PSHQueryRBInfo): Integer; stdcall; external 'shell32.dll' name 'SHQueryRecycleBinA';
function StrFormatByteSize64(dw: I64; szBuf: PChar; uiBufSize: Cardinal): PChar; stdcall; external 'shlwapi.dll' name 'StrFormatByteSize64A';
function TranslateMessage(lpMsg: Pointer): Boolean; stdcall; external 'user32.dll' name 'TranslateMessage';
function wvsprintf(Output: PChar; Format: PChar; arglist: PChar): Integer; stdcall; external 'user32.dll' name 'wvsprintfA';
procedure PostQuitMessage(nExitCode: Integer); stdcall; external 'user32.dll' name 'PostQuitMessage';

procedure FillChar(Destination: Pointer; Length: Cardinal; Fill: Byte);
asm
{     ->EAX     Pointer to destination  }
{       EDX     count   }
{       CL      value   }
  PUSH    EDI
  MOV     EDI,EAX { Point EDI to destination              }
  MOV     CH,CL   { Fill EAX with value repeated 4 times  }
  MOV     EAX,ECX
  SHL     EAX,16
  MOV     AX,CX
  MOV     ECX,EDX
  SAR     ECX,2
  JS      @@exit
  REP     STOSD   { Fill count DIV 4 dwords       }
  MOV     ECX,EDX
  AND     ECX,3
  REP     STOSB   { Fill count MOD 4 bytes        }

@@exit:
  POP     EDI
end;    

function WndProc(hwnd, message: Cardinal; wParam, lParam: Integer): Integer; stdcall;
var
  Buffer: array[0..255] of Char;
  SHQueryRBInfo: TSHQueryRBInfo;
begin
  Result := 0;
  case message of
    $0113:
    begin 
      FillChar(@SHQueryRBInfo, SizeOf(TSHQueryRBInfo), 0);
      SHQueryRBInfo.cbSize := SizeOf(TSHQueryRBInfo);
      SHQueryRecycleBin(nil, @SHQueryRBInfo);
      StrFormatByteSize64(SHQueryRBInfo.i64Size, Buffer, 255);
      SetWindowText(L1, Buffer);
      wvsprintf(Buffer, '%lu', @SHQueryRBInfo.i64NumItems);
      SetWindowText(L2, Buffer);
    end;

    $0111: if wParam = 14 then
    begin
      KillTimer(hwnd,1);
      PostQuitMessage(0);
    end;

    $0002: PostQuitMessage(0);

    else Result := DefWindowProc(hwnd, message, wParam, lParam);
  end;
end;

begin
  with Wnd do
  begin
    lpfnWndProc := @WndProc;
     hbrBackground := 16;
    lpszClassName := 'XPU';
    hIcon := LoadIcon(0, PChar(32512));
    hCursor := LoadCursor(0, PChar(32512));
  end;
  RegisterClass(@Wnd);

  fWnd := CreateWindowEx($00000001, 'XPU', 'Kosz', $10080000, (GetSystemMetrics(0) div 2)-350, (GetSystemMetrics(1) div 2)-250, 350, 250, 0, 0, Wnd.hInstance, NIL);
  CreateWindowEx($10000, 'BUTTON', 'Zamknij', $40000000 or $10000000, 100, 180, 133, 33, fWnd, 14, Wnd.hInstance, nil);
  CreateWindowEx($10000, 'STATIC', 'Calkowity rozmiar plikow w koszu:', $40000000 or $10000000, 20, 40, 240, 25, fWnd, 0, Wnd.hInstance, nil);
  CreateWindowEx($10000, 'STATIC', 'Liczba plikw w koszu:', $40000000 or $10000000, 20, 80, 240, 25, fWnd, 0, Wnd.hInstance, nil);
  L1 := CreateWindowEx($10000, 'STATIC', '', $40000000 or $10000000, 250, 40, 50, 25, fWnd, 0, Wnd.hInstance, nil);
  L2 := CreateWindowEx($10000, 'STATIC', '', $40000000 or $10000000, 250, 80, 50, 25, fWnd, 0, Wnd.hInstance, nil);
  SetTimer(fWnd, 1, 1000, nil);

  while GetMessage(@msg, 0, 0, 0) do
  begin
    TranslateMessage(@msg);
    DispatchMessage(@msg);
  end;
end.